# Jeeves

Jeeves will take care of your boring tasks so you don't have to worry.

![Python 3.7+](https://img.shields.io/badge/python-3.7%2B-blue)

- [Jeeves](#jeeves)
  - [Documentation](#documentation)
  - [Running it](#running-it)
    - [Using the cli](#using-the-cli)
  - [Contributing](#contributing)

## Documentation

Documentation is accesible and readable in the [docs](./docs) folder.

## Running it

### Using the cli

Jeeves provide a useful CLI to execute your flows in a very convenient way, for example. given a test flow:

``` javascript
// definition.json
{
    "name": "Test flow",
    "tasks": [
        {
            "name": "Say hello",
            "type": "jeeves.core.tasks.shell:ShellTask",
            "parameters": {
                "script": "#!/bin/bash\necho HELLO WORLD!"
            }
        }
    ]
}
```

You can run it using `jeeves execute definition.json`:

```
$ jeeves execute --output  definition.json
(i) Running flow from definition.json
=== Running flow: Test flow
ok! Running step [1/1]: Say hello
=== Full output:
HELLO WORLD
```

> You can also run the same command from stdin using:
> - `cat definition.json | jeeves execute --output -`
> - `jeeves execute --output - < definition.json`

## Contributing

TODO
