"""
This is a collection of Tasks provided for testing purposes only.
"""
from typing import Text, Optional

from jeeves.core.objects import Result
from .base import Task


class StubSuccessTask(Task):
    id = "stub/success"

    def execute(self, message=None):
        return Result(success=True)


class StubNonSuccessTask(Task):
    id = "stub/non-success"

    def execute(self):
        return Result(output="error!", success=False)


class StubUncaughtExceptionTask(Task):
    id = "stub/uncaught-exception"

    def execute(self):
        raise Exception("Oh god...")


class StubNoParametersTask(StubSuccessTask):
    """
    An empty task that provides no configurable parameters.
    """

    id = "stub/no-parameters"


class StubParametersTask(StubSuccessTask):
    """
    An empty task that provide two configurable parameters.
    """

    id = "sub/parameters"

    class Parameters(Task.Parameters):
        mandatory: Text
        non_mandatory: Optional[Text] = None
