import factory
from faker import Faker

from jeeves.core.objects import Flow, Task
from jeeves.core.registry import TaskRegistry

fake = Faker()


class TaskFactory(factory.Factory):
    name = fake.sentence()
    type = factory.Iterator(TaskRegistry.tasks)
    parameters = {"script": "#!/bin/bash\necho test"}

    class Meta:
        model = Task


class FlowFactory(factory.Factory):
    name = fake.name()
    tasks = factory.LazyFunction(lambda: [TaskFactory() for _ in range(0, 2)])

    class Meta:
        model = Flow
