from jeeves.core.executor import Executor
from .factories import FlowFactory, TaskFactory


def test_executor_success_task_ok():
    task = TaskFactory(type="jeeves.core.tasks.stub:StubSuccessTask")
    flow = FlowFactory(tasks=[task])
    runner = Executor(flow)
    runner.start()
    assert runner._execution.steps[0].result
    assert runner._execution.steps[0].result.success is True
    assert runner._execution.success is True


def test_executor_non_success_task_ok():
    task = TaskFactory(type="jeeves.core.tasks.stub:StubNonSuccessTask")
    flow = FlowFactory(tasks=[task])
    runner = Executor(flow)
    runner.start()
    assert runner._execution.steps[0].result
    assert runner._execution.steps[0].result.success is False
    assert runner._execution.success is False


def test_executor_uncaught_exception_in_task_ok():
    task = TaskFactory(type="jeeves.core.tasks.stub:StubUncaughtExceptionTask")
    flow = FlowFactory(tasks=[task])
    runner = Executor(flow)
    runner.start()
    assert runner._execution.steps[0].result
    assert runner._execution.steps[0].result.success is False
    assert runner._execution.success is False
