import pytest

from jeeves.core.registry import TaskRegistry
from jeeves.core.tasks.base import Task


def test_registry_get_task_cls_ok():
    task = TaskRegistry.get_task_cls("jeeves.core.tasks.stub:StubSuccessTask")
    assert issubclass(task, Task) and not isinstance(task, Task)


def test_registry_get_task_ko():
    with pytest.raises(TaskRegistry.TaskDoesNotExist):
        TaskRegistry.get_task_cls("non.existant:task")
