import pytest
import pydantic

from jeeves.core.registry import TaskRegistry


def test_task_with_empty_parameters_ok():
    task = TaskRegistry.get_task_cls("jeeves.core.tasks.stub:StubNoParametersTask")
    task()
    task(parameters=None)
    task(parameters={})


def test_task_with_parameters_ok():
    task = TaskRegistry.get_task_cls("jeeves.core.tasks.stub:StubParametersTask")
    task(parameters=dict(mandatory="text", non_mandatory="text"))


def test_task_with_parameters_ko():
    task = TaskRegistry.get_task_cls("jeeves.core.tasks.stub:StubParametersTask")
    with pytest.raises(pydantic.ValidationError):
        task(parameters=dict(thisshould="fail"))
