# Generated by Django 2.2.5 on 2019-09-23 20:56

import uuid

import django.db.models.deletion
from django.db import models, migrations

import jeeves.db.models


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Flow",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("modified_at", models.DateTimeField(auto_now=True)),
                ("name", models.CharField(max_length=64)),
                ("_definition", models.TextField()),
            ],
            options={"abstract": False},
            bases=(models.Model, jeeves.db.models.DefinitionMixin),
        ),
        migrations.CreateModel(
            name="Task",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("modified_at", models.DateTimeField(auto_now=True)),
                ("type", models.CharField(max_length=32)),
                ("_definition", models.TextField()),
            ],
            options={"abstract": False},
            bases=(jeeves.db.models.DefinitionMixin, models.Model),
        ),
        migrations.CreateModel(
            name="Run",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("modified_at", models.DateTimeField(auto_now=True)),
                (
                    "status",
                    models.CharField(
                        choices=[("pending", "Pending"), ("finished", "Finished")],
                        default="pending",
                        max_length=32,
                    ),
                ),
                ("success", models.BooleanField(default=True)),
                ("_definition", models.TextField()),
                ("_result", models.TextField(default="{}")),
                (
                    "flow",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="db.Flow"
                    ),
                ),
            ],
            options={"abstract": False},
            bases=(jeeves.db.models.DefinitionMixin, models.Model),
        ),
    ]
